generic rec print = case $a -> unit of 
  << int ->     unit >> -> print_int
| << float ->   unit >> -> print_float
| << string ->  unit >> -> 
    (fun x -> print_string "\""; print_string x; print_string "\"")
| << char ->    unit >> -> 
    (fun x -> print_string "\'"; print_char x; print_string "\'")
| << $a list -> unit >> -> 
    (fun lst -> 
      print_string "[";
      let rec printer = function
	  [] -> print_string "]"
	| [x] -> print x; print_string "]"
	| x :: xs -> print x; print_string "; "; printer xs
      in
      printer lst)
;;
