(* generic recursive bindings *)

generic rec print = case 
| int -> unit => print_int
| $a list -> unit => fun l -> List.iter print l
;;

(* mutual recursion is also possible *)
(* hopefully... *)
generic rec print = case 
| int -> unit => print_int
| $a list -> unit => fun l -> List.iter print2 l
and print2 = case
| float -> unit => print_float
| $a list -> unit => fun l -> List.iter print l
;;
