open Rdigest

(*
exception Type_match_failure of (rpath * type_info) rtype * (rpath * type_info) rtype * string * int * int
*)
exception Type_match_failure of (rpath * type_info) rtype * string * int * int

val type_of : dyn -> (rpath * type_info) rtype

val is_instance : 'a rtype -> 'a rtype -> bool

val dynamic_comp : 
    (rpath * type_info) rtype array -> 'a -> ('a * (rpath * type_info) rtype)
val fail : (rpath * type_info) rtype -> string -> int -> int -> 'a
val coerce_comp : 
    (string * int * int) -> (rpath * type_info) rtype array -> 
      ('a * (rpath * type_info) rtype) -> 'a 

(*** Generic primitives are defined in pervasives *)
